/* a very simple module: put a header in the reply with the number of hits this process has received */
/* See http://www.hoboes.com/Mimsy/?ART=636 for tutorial */
#include "httpd.h"
#include "http_config.h"
#include "apr_strings.h"

static uint hitCount = 0;

static int myHitsCounter(request_rec *request) {
	//if main exists, this is an internal redirect, which means we've already acted on this "hit"
	if (!request->main) {
		char *hitString;

		hitCount++;
		hitString = apr_itoa(request->pool, hitCount);

		apr_table_set(request->headers_out, "X-Process-Hits", hitString);
	}
	return OK;
}

static void myRegisterHooks(apr_pool_t *p) {
	ap_hook_fixups(myHitsCounter, NULL, NULL, APR_HOOK_MIDDLE);
}

module AP_MODULE_DECLARE_DATA myhits_module = {
	STANDARD20_MODULE_STUFF,
	NULL, /* create per-directory config structures */
	NULL, /* merge per-directory config structures */
	NULL, /* create per-server config structures */
	NULL, /* merge per-server config structures */
	NULL, /* command handlers */
	myRegisterHooks /* register hooks */
};
